#include "MyWidget.h"
#include "ui_Login.h"
#include <QMessageBox>

MyWidget::MyWidget(QWidget * parent):QWidget(parent) {
	MYSQL_ROW Row;
	MYSQL_FIELD * fields;
	unsigned int i,j = 0;

	setupUi(this);
 
	if(!(Db = mysql_init(NULL))){
		QMessageBox::critical(this,"Error!",QString("Error #%1: %2").arg(mysql_errno(Db)).arg(mysql_error(Db)));
		return;
	}

	if(mysql_options(Db,MYSQL_SET_CHARSET_NAME,"utf8") != 0){
		QMessageBox::critical(this,"Error!",QString("Error #%1: %2").arg(mysql_errno(Db)).arg(mysql_error(Db)));
		return;
	}

	Connected = Connect();

	if(Connected){
		if(mysql_query(Db,"select * from DC01") != 0){
			QMessageBox::critical(this,"Error!",QString("Error #%1: %2").arg(mysql_errno(Db)).arg(mysql_error(Db)));
			return;
		}
		if(!(Result = mysql_store_result(Db))){
			QMessageBox::critical(this,"Error!",QString("Error #%1: %2").arg(mysql_errno(Db)).arg(mysql_error(Db)));
			return;
		}
	}

	tableWidget->setColumnCount(Result->field_count);
	tableWidget->setRowCount(Result->row_count);

	fields = mysql_fetch_fields(Result);

	for(i = 0; i < Result->field_count; i++){
		QTableWidgetItem * headerItem = new QTableWidgetItem(fields[i].name);
		tableWidget->setHorizontalHeaderItem(i,headerItem);
	}	

	while((Row = mysql_fetch_row(Result))){
		for(i = 0; i < Result->field_count; i++){
			QTableWidgetItem * newItem = new QTableWidgetItem(Row[i]);
			tableWidget->setItem(j, i, newItem);
		}
		j++;
	}
}

MyWidget::~MyWidget(){
	if(Db) mysql_close(Db);
}

int MyWidget::Connect(){
	QDialog * Dialog = new QDialog(this);
	Ui::Dialog * Login = new Ui::Dialog;
	Login->setupUi(Dialog);
	Dialog->exec();
	if(mysql_real_connect(Db,qPrintable(Login->Host->text()), \
		qPrintable(Login->User->text()), \
		qPrintable(Login->Password->text()), \
		qPrintable(Login->Database->text()), \
		0,NULL,0)) return 1;
	else {
		QMessageBox::critical(this,"Error!",QString("Error #%1: %2").arg(mysql_errno(Db)).arg(mysql_error(Db)));
		return 0;
	}
}
